/*
 *
 *
 */

Ext.namespace("ARV");

ARV.modcred = (function() {
    /*
     * Public
     */

    var credstore = new Ext.data.Store({
        reader: new Ext.data.JsonReader({
            root :'data',
            successProperty: 'success',
        },[
            {name : 'cred'},
            {name : 'id'},
        ]),
        url: 'arv/get_cred',
    });
    return {
        load: function(node) {
            credstore.removeAll();
            credstore.baseParams={node: node};
            credstore.load();
        },
        openWindow: function(node){
            credstore.baseParams={node: node};
            credstore.load();
            columns = [
                {header: Ext.i18n.cred_header, sortable: true, dataIndex: 'cred'},
                {header: 'ID', sortable: true, dataIndex: 'id', hidden: true}
            ];
            var cardcontent = new ARV.GridPanel({
                store: credstore,
                columns: columns,
                title: Ext.i18n.cred,
                deleteUrl: 'arv/del_cred',
                btnAddEvent: 'credadd',
                btnDelEvent: 'credchanged'
            });

            var wincred = new ARV.PopupWindow({
                title: Ext.i18n.cred_title,
                items: [cardcontent],
                bbar: ['->', {
                    text: Ext.i18n.exit,
                    handler: function(){
                        wincred.close()
                    }
                }]
            }).show();
        },
        openCredWindow: function(node, reload_store){
            var cardcontent = [{
                id: 'cardmc-0',
                xtype: 'form',
                border: false,
                items: [{
                    xtype : "radio",
                    checked: true,
                    fieldLabel : Ext.i18n.generated_new_cred,
                    name : "cred_type",
                    inputValue: 'new_cred'
                },{
                    xtype : "radio",
                    fieldLabel : Ext.i18n.imported_old_cred,
                    name : "cred_type",
                    inputValue: 'old_cred'
                }],
            },{
                id: 'cardmc-1-old',
                xtype: 'form',
                fileUpload: true,
                border: false,
                items: [{
                    xtype: 'fileuploadfield',
                    id: 'private_key',
                    buttonText: Ext.i18n.add,
                    buttonOnly: true,
                    fieldLabel : Ext.i18n.addcred_private_key,
                    listeners: {
                        'fileselected': function(fb, v){
                            Ext.getCmp('private_key').disable() ;
                            if ( Ext.getCmp('public_key').disabled == true ) {
                                Ext.getCmp('save-button').enable();
                            }
                        }
                    }
                }, {
                    xtype: 'fileuploadfield',
                    id: 'public_key',
                    buttonText: Ext.i18n.add,
                    buttonOnly: true,
                    fieldLabel : Ext.i18n.addcred_public_key,
                    listeners: {
                        'fileselected': function(fb, v){
                            Ext.getCmp('public_key').disable()
                            if ( Ext.getCmp('private_key').disabled == true ) {
                                Ext.getCmp('save-button').enable();
                            }
                        }
                    }
                }, {
                    xtype: 'textfield',
                    id: 'password',
                    fieldLabel : Ext.i18n.addcred_passwd,
                    inputType: 'password',
                    allowBlank:false
                }]
            },{
                id: 'cardmc-1-new',
                xtype: 'form',
                border: false,
                items: [{
                    xtype: "textfield",
                    fieldLabel: Ext.i18n.addcred_name,
                    width: 150,
                    id: 'credname',
                    name: 'name',
                    allowBlank:false
                },{
                    xtype: "textfield",
                    fieldLabel: Ext.i18n.passwd,
                    width: 150,
                    id: 'passwd',
                    name: 'passwd',
                    inputType: 'password',
                    allowBlank:false
                },{
                    xtype : "radio",
                    checked: true,
                    fieldLabel : Ext.i18n.autosign_cred,
                    name : "cred_priv_type",
                    inputValue: 'autosigned'
                },{
                    xtype : "radio",
                    fieldLabel : Ext.i18n.cred_request,
                    name : "cred_priv_type",
                    inputValue: 'cred_request'
                }],
            }];

            var nbcard = 0;
            var navHandler = function(incr){
                var l = Ext.getCmp('addcred-wizard-panel').getLayout();
                var i = l.activeItem.id.split('cardmc-')[1];
                var next = parseInt(i) + incr;
                switch (next) {
                    case 0:  Ext.getCmp('save-button').disable();
                    break;
                    case 1:
                            var include_type = Ext.getCmp('cardmc-0').getForm().getValues()['cred_type'];
                            if (include_type == 'new_cred') {
                                next = 2;
                                Ext.getCmp('save-button').enable();
                            };
                             /*if ((Ext.getCmp('nodename').getValue() == '') ||
                                (Ext.getCmp('tmplnode').getValue() == '')) {
                                error_msg(Ext.i18n.field_empty)
                                return;
                            };
                            Ext.getCmp('save-button').enable();
                            property_store.removeAll();
                            property_store.baseParams={tmplnodeid: Ext.getCmp('tmplnode').getValue()};
                            property_store.load();*/
                    break;
                };
                l.setActiveItem(next);
                nbcard = next;
                Ext.getCmp('cardmc-prev').setDisabled(next==0);
                Ext.getCmp('cardmc-next').setDisabled(next>0);

            };

            var wizard = {
                id:'addcred-wizard-panel',
                xtype: 'panel',
                layout:'card',
                border: false,
                activeItem: nbcard,
                bbar: ['->', {
                    id: 'cardmc-prev',
                    text: '&laquo; '+ Ext.i18n.previous,
                    handler: navHandler.createDelegate(this, [-1]),
                    disabled: true,

                },{
                    id: 'cardmc-next',
                    text: Ext.i18n.next+' &raquo;',
                    handler: navHandler.createDelegate(this, [1]),

                }],
                items: cardcontent,
                buttons: [{
                    text: Ext.i18n.cancel,
                    handler: function(){
                        wincred2.destroy();
                    }
                },{
                    id: 'save-button',
                    text: Ext.i18n.save,
                    disabled: true,
                    handler: function() {
                        if (nbcard==1) {
                            fb = Ext.getCmp('cardmc-1-old').getForm();
                            if (fb.isValid){
                                Ext.getCmp('public_key').enable();
                                Ext.getCmp('private_key').enable();
                                fb.submit({
                                    url: 'arv/add_imported_cred',
                                    //waitMsg: Ext.i18n.dialog_submit,
                                    params: {node: node},
                                    success: response_success,
                                });
                            };
                        } else {
                            fb = Ext.getCmp('cardmc-1-new').getForm();
                            if (fb.isValid){
                                fb.submit({
                                    url: 'arv/add_generated_cred',
                                    params: {node: node},
                                    success: response_success,
                                });
                            };
                        }
                    }
                }]
            };
            var response_success = function(response, options){
                wincred2.destroy();
                if (reload_store == null) {
                    ARV.observable.fireEvent("credchanged");
                } else {
                    reload_store.load()
                }
            };
            var wincred2 = new ARV.PopupWindow({
                title: Ext.i18n.addnode1_title,
                items: [wizard]
            }).show();
        }
    };
})();

// vim: ts=4 sw=4 expandtab
