/*
 *
 *
 */

Ext.namespace("ARV");

ARV.treenode2 = (function() {
    /*
     * Private
     */
	var tnode2grid = new ARV.GridNode({
		region: 'center',
		title: Ext.i18n.node2,
		btnAddEvent: 'addconnect',
		btnModEvent: 'modconnect'
	});
	tnode2grid.getSelectionModel().on('rowselect', function() {ARV.observable.fireEvent('viewconnectchanged')}, this);
    /*
     * Public
     */

    return {

        get: function() {
            return tnode2grid;
        },

        load: function(node) {
			store=tnode2grid.getStore()
            store.removeAll();
			if (node != null) {
	            store.baseParams={id: node, connected: 'true'};
    	        store.load();
			};
            ARV.observable.fireEvent('viewconnectchanged');
        },

        getSelectedId: function() {
            if (tnode2grid.getSelectionModel().hasSelection()) {
                return tnode2grid.getSelectionModel().getSelected().get('id');
            } else {
                return null
            }
        },

        getSelectedName: function() {
            if (tnode2grid.getSelectionModel().hasSelection()) {
                return tnode2grid.getSelectionModel().getSelected().get('node');
            } else {
                return null
            }
        }
    };
})();
