Ext.namespace("ARV");

ARV.viewcred = (function() {

    var vcstore = new Ext.data.Store({
        reader: new Ext.data.JsonReader({
            root :'data',
            successProperty: 'success',
        },[
            {name: 'node'},
            {name: 'state'},
            {name: 'id'},
        ]),
        url: 'arv/get_nodes_state',
    });
    var columns = [{id: 'node', header: Ext.i18n.node, sortable: true, dataIndex: 'node'},
        {header: 'state', header: Ext.i18n.certif_state, sortable: true, dataIndex: 'state'},
        {header: 'id', sortable: true, dataIndex: 'id', hidden: true}
    ];
    var vcgrid = new ARV.GridPanel({
        layout: 'fit',
        region: 'center',
        store: vcstore,
        columns: columns,
        deleteUrl: 'arv/del_node',
        btnAddEvent: 'treenode1add',
        btnDelEvent: 'treenode1del',
        btnModEvent: 'treenode1mod'
    });
    bbar = vcgrid.getBottomToolbar();
    bbar.add({
        //modify credential
        text: Ext.i18n.credential,
        iconCls: 'arv-modify',
        handler: function(btn, ev) {
            ARV.observable.fireEvent('modifycred');
        },
            scope: this
    });
    vcgrid.getSelectionModel().on('rowselect', function() {ARV.observable.fireEvent('treenodecertchanged')}, this);
    return {
        get: function() {
            return vcgrid;
        },
        load: function() {
            vcstore.removeAll();
            vcstore.load();
        },
        getSelectedId: function() {
            if (vcgrid.getSelectionModel().hasSelection()) {
                return vcgrid.getSelectionModel().getSelected().get('id');
            } else {
                return null
            }
        },
    }
})();
